#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define N 114514

struct person{
    int id; 
    char name[40]; 
    char prefecture[20]; 
    char phone[20];
};

struct Node{ // BSTのNodeを定義する
    struct person data;
    struct Node* left;
    struct Node* right;
};

struct Node* insert(struct Node* root, struct person data){  // BSTにデータを挿入する
    if (root == NULL){
        struct Node* newNode=(struct Node*)malloc(sizeof(struct Node));
        newNode->data=data;
        newNode->left=NULL;
        newNode->right=NULL;
        return newNode;
    }

    if (data.id<root->data.id){    //小さいIDを左の部分木へ、大きいIDを右の部分木に入れる
        root->left=insert(root->left, data);
    } else if (data.id>root->data.id){
        root->right=insert(root->right, data);
    }

    return root;
}

void printRecord(struct Node* root, int id){  // データを出力するための関数
    if (root == NULL){ // 入力したidが表にない場合メッセージを返す
        printf("ID %d not found\n", id);
        return;
    }

    if (id == root->data.id){ // 今のNodeが入力したidであるなら出力する
        //printf("ID: %d\n", root->data.id);
        printf("Name: %s\n", root->data.name);
        printf("Prefecture: %s\n", root->data.prefecture);
        printf("Phone: %s\n", root->data.phone);
    } else if (id<root->data.id){ // そうでない場合左と右の部分木を捜す
        printRecord(root->left, id);
    } else{
        printRecord(root->right, id);
    }
}

void freeTree(struct Node* root){ // 今回はいらなくでもいいが
    if (root != NULL){
        freeTree(root->left);
        freeTree(root->right);
        free(root);
    }
}

struct person Rec[N];

int main(){
    FILE* fp_in; // FILE型構造体
    fp_in=fopen("data_rec.csv", "r"); 

    struct Node* root=NULL;

    for (int i=0; fscanf(fp_in, "%d,%[^,],%[^,],%s", &Rec[i].id, Rec[i].name, Rec[i].prefecture, Rec[i].phone) != EOF; i++){
        root=insert(root, Rec[i]); //　入力したデータをBSTに入れる
    }

    while (1){
        int x;
        printf("ID: ");
        scanf("%d", &x);
        if (x<0) break;

        printRecord(root, x); // 入力したIDをBSTに捜す
    }

    fclose(fp_in);
    freeTree(root); // ファイルを閉じる

    return 0;
}
